import pandas as pd
import os
import re
from collections import Counter

folder_path = './data/titles.txt'


all_data = []

# count = 1

# for file in os.listdir(folder_path):
#     if file.endswith('.xlsx'):
#         file_path = os.path.join(folder_path, file)

#         current_df = pd.read_excel(file_path)
#         elements_list = current_df.iloc[:, 2].tolist()
#         all_data = all_data + elements_list
#         print(f"{count} -> {file}")
#         count += 1

with open('./data/titles.txt', 'r', encoding='utf-8') as file:
    string_list = file.readlines()


modified_list = []

# پیمایش رشته‌ها در لیست
for item in string_list:
    # جایگزینی تمام اعداد با NUM
    modified_item = re.sub(r'\d', ' NUM ', item)
    modified_list.append(modified_item.replace("\n", '').strip())
    
modified_list.sort()
modified_list = list(set(modified_list))
   
titles = ''
for item in modified_list:
    n_item = ''.join(str(item).replace("#",' ').strip() + "\n")
    hhh = "مواد  NUM  NUM  NUM  ، NUM  NUM  NUM  ، NUM  NUM  NUM  ، NUM  NUM  NUM  ، NUM  NUM  NUM"
    n_item = n_item.replace("NUM NUM NUM NUM", 'NUM').strip()
    n_item = n_item.replace("NUM  NUM  NUM  NUM", 'NUM').strip()
    n_item = n_item.replace("NUM  NUM  NUM", 'NUM').strip()
    n_item = n_item.replace("NUM NUM NUM", 'NUM').strip()
    n_item = n_item.replace("NUM NUM", 'NUM').strip()
    n_item = n_item.replace("NUM  NUM", 'NUM').strip()
    titles += n_item + "\n"

refs_list = titles.splitlines()
sorted_list = sorted(refs_list, key=lambda x: len(x.split()))

titles = ''
for item in sorted_list:
    cleaned_text = re.sub(r'\s+', ' ', item)
    titles += cleaned_text + "\n"

refs_list = titles.splitlines()
string_counts = Counter(refs_list)
unique_strings_with_counts = [f"{value} - {key}" for key, value in string_counts.items()]

 
sorted_list = sorted(unique_strings_with_counts, reverse=True)

titles = ''
for item in sorted_list:
    cleaned_text = re.sub(r'\s+', ' ', item)
    titles += cleaned_text + "\n"
    
with open('./data/excels/titles6.txt', 'w', encoding='utf-8') as file:
    file.write(titles)
    
pass


